package JunitTests;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;
import org.junit.jupiter.api.MethodOrderer.OrderAnnotation;

import de.hs_mannheim.informatik.bank.domain.Konto;
import de.hs_mannheim.informatik.bank.facade.Banksystem;
@TestMethodOrder(OrderAnnotation.class) 
class BankSystemJunit {
	public Banksystem bs = new Banksystem("NormalString");

	@Test
	@Order(1)
	void testBanknameNull() {
		Banksystem bsx = new Banksystem(null);
		assertEquals(null,bsx.getBankname());
	}
	@Test
	@Order(2)
	void testBankname() {
		String s = "IKnowThatThisMustBeTheBiggestStringYouHaveEverSeen";
		Banksystem bsx = new Banksystem(s);
		assertEquals("IKnowThatThisMustBeTheBiggestStringYouHaveEverSeen",bsx.getBankname());
	}
	@Test
	@Order(3)
	void testEinzahlenMinusStand() {
		bs.kontoAnlegen("Dextaa");
		assertEquals(10,bs.einzahlen(1000, 10));
	}
	@Test
	@Order(4)
	void testEinzahlenZeroStand() {
		bs.kontoAnlegen("Ryan");
		assertEquals(0,bs.einzahlen(1001, 0));
	}
	@Test
	@Order(5)
	void testEinzahlenPostiveStand() {
		bs.kontoAnlegen("Renold");
		bs.einzahlen(1002, 24924892);
		assertEquals( 24924892,bs.einzahlen(1002, 0));
	}
	@Test
	@Order(6)
	void testEinzahlenOverflowStand() {
		bs.kontoAnlegen("Awesome");
		bs.einzahlen(1003, Integer.MAX_VALUE);
		assertEquals(Integer.MAX_VALUE,bs.standsuchen(1003));
	}
	@Test
	@Order(7)
	void testEinzahlen() {
		assertEquals(0,bs.einzahlen(1033, Integer.MAX_VALUE));
	}



}
