package JunitTests;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.MethodOrderer.OrderAnnotation;
import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;

import de.hs_mannheim.informatik.bank.domain.Konto; 
//Junit is runs test alphabetic, so we will make it run by order
@TestMethodOrder(OrderAnnotation.class) 
class kontoClassJunit {	
	//@Oder Annotation

	@Test
	@Order(1)
	public void testConstructorNullKontoNummer() {
		Konto k = new Konto(null);
		assertEquals(1000,k.getKontonummer());	
	}
	@Test
	@Order(2)
	public void testConstructorNullStand() {
		Konto k = new Konto("bs");
		assertEquals(1001,k.getKontonummer());	
		assertEquals(0,k.getStand());
	}
	@Test
	@Order(3)
	public void ConstructorBigNameStand() {
		Konto k = new Konto("ThisTextISverYBigThatItwontContainitAtAll");
		assertEquals(0,k.getStand());
	}
	
	@Test
	@Order(4)
	public void ConstructorBigNameKonto() {
		Konto k = new Konto("ThisTextISverYBigThatItwontContainitAtAll");
		assertEquals(1003,k.getKontonummer()); 
	}
	@Test
	@Order(5)
	public void ConstructorEinzahlen() {
		Konto k = new Konto("Ryan Ronalds");
		k.einzahlen(100);
		assertEquals(100,k.getStand()); 
	}
	@Test
	@Order(6)
	public void ConstructorMehrereEinzahlen() {
		Konto k = new Konto("Ryan Ronalds");
		k.einzahlen(100);
		k.einzahlen(11);
		k.einzahlen(7);
		k.einzahlen(135);
		assertEquals(253,k.getStand()); 
	}
	@Test
	@Order(7)
	public void ConstructorMehrereEinzahlenMitMinus() {
		Konto k = new Konto("Ryan Ronalds");
		k.einzahlen(100);
		k.einzahlen(11);
		k.einzahlen(57);
		k.einzahlen(-135);
		assertEquals(33,k.getStand()); 
	}
	
	@Test
	@Order(8)
	public void ConstructorMehrere() {
		Konto k = new Konto("Ryan Ronalds");
		k.einzahlen(100);
		k.einzahlen(11);
		k.einzahlen(57);
		k.einzahlen(0);
		assertEquals(168,k.getStand()); 
	}
	//Testing Delta or the third parameter
	@Test
	@Order(9)
	public void test() {
		float testing = 18.9F;
		assertEquals(18.9,testing,0.001);
	}
	
	
	
	 
	
	

	
	
	
	
	

	
	
	

}
