package de.hs_mannheim.informatik.bank.UI;



import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import de.hs_mannheim.informatik.bank.facade.Banksystem;

public class UI {
	private Banksystem bs;
	Scanner sc = new Scanner(System.in);

	public UI(Banksystem bs) {
		this.bs = bs;
		hauptmenu();
	}

	private void hauptmenu()  {
		System.out.println("Willkommen bei der " + bs.getBankname() + "!");

		mainloop: 
			while (true) {
				System.out.println();
				System.out.println("--------");
				System.out.println("Hauptmenu");
				System.out.println("1 -> Konten anzeigen");
				System.out.println("2 -> Konto anlegen");
				System.out.println("3 -> Einzahlen");
				System.out.println("4 -> Auszahlen");
				System.out.println("5 -> Kontostand Suchen");
				System.out.println("6 -> Verlauf Zeigen");
				System.out.println("7 -> Speichern");
				System.out.println("8 -> laden");
				System.out.println("9 -> Beenden");
				System.out.println();

				System.out.print("> ");
				int input = Integer.parseInt(sc.nextLine());
				System.out.println();

				switch(input) {
					case 1: kontenAnzeigen(); break;
					case 2: kontoAnlegen(); break;
					case 3: einzahlen(); break;
					case 4: ausziehen(); break;
					case 5: standSuchen(); break;					
					case 6: zeigeVerlauf(); break;
					case 7: speichern(); break;
					case 8: laden(); break;
					


					
					case 9: break mainloop;
				}
			}

		System.out.println("Auf Wiedersehen!");

	} // hauptmenu

	private void kontenAnzeigen() {		
		String[] konten = bs.getKontenliste();
		if (konten.length > 0) {
			System.out.println("Folgende Konten sind aktuell verfügbar:");
			for (String s : konten) {
				System.out.println(s);
			}
		} else {
			System.out.println("Bisher keine Konten angelegt.");
		}
	}

	private void kontoAnlegen() {
		System.out.println("Bitte den Namen des Kontoinhabers angeben: ");
		String name = sc.nextLine();

		int kontonummer = bs.kontoAnlegen(name);
		System.out.println("Konto mit der Nummer " + kontonummer + " neu angelegt.");
	}
	private void einzahlen()
	{
		System.out.println("Bitte die Konto nummer angeben");
		int nummer = Integer.parseInt(sc.nextLine());
		long result = bs.standsuchen(nummer);
		if(result == -1)
		{
			System.out.println("Konto nicht gefunden!");
			return;
		}
		System.out.println("Bitte den Betrag angeben");
		long betrag = Long.parseLong(sc.nextLine());
		System.out.println("Konto stand betraegt" + bs.einzahlen(nummer, betrag));
	}
	private void standSuchen()
	{
		System.out.println("Bitte die Konto nummer angeben");
		int nummer = Integer.parseInt(sc.nextLine());
		long result = bs.standsuchen(nummer);
		System.out.println("Der Kontostand betreagt:" + result);
		
	}
	private void ausziehen()
	{
		System.out.println("Bitte die Konto nummer angeben");
		int nummer = Integer.parseInt(sc.nextLine());
		long result = bs.standsuchen(nummer);
		if(result == -1)
		{
			System.out.println("Konto nicht gefunden!");
			return;
		}
		System.out.println("Bitte den Betrag angeben");
		long betrag = Long.parseLong(sc.nextLine());
		System.out.println("Konto stand betraegt" + bs.ausziehen(nummer, betrag));
		
	}
	private void zeigeVerlauf()
	{
		System.out.println("Bitte die Konto nummer angeben");
		int nummer = Integer.parseInt(sc.nextLine());
		List<Long> result = bs.zeigeVerlauf(nummer);
		if(result == null)
		{
			System.out.println("Konto nicht gefunden!");
			return;
		}
		System.out.println("Konto verlauf:");
		for(Long x : result )
		{
			System.out.println(x);
		}
		
		
	}
	private void speichern()
	{
		if(bs.speichern())
		{
			System.out.println("Date gespeichert");
			return;
		}else
		{
			System.out.println("Ein Fehler ist aufgetreten");
		}
		
	}
	private void laden() 
	{
		try {
		if(bs.laden())
		{
			System.out.println("Data gespeichert");
			return;
		}
		}
		catch(ClassNotFoundException a)
		{
			System.out.println("Ein Fehler ist aufgetreten");

		}
	}

}
