package de.hs_mannheim.informatik.bank.domain;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class Konto implements Serializable{
	private static int kontozähler = 0;
	private List<Long> history = new ArrayList<Long>();
	
	private int nummer;
	private long stand = 0;
	private String inhaber;

	public Konto(String inhaber) {
		nummer = 1000 + kontozähler++;
		this.inhaber = inhaber;
	}
	
	public long einzahlen(long betrag)
	{
		stand += betrag;
		return this.stand;
	}
	public long ausziehen(long betrag)
	{
		stand -= betrag;
		return this.stand;
	}
	
	public int getKontonummer() {
		return nummer;
	}
	public long getStand()
	{
		return stand;
	}
	@Override
	public String toString() {
		return "Konto [nummer=" + nummer + ", inhaber=" + inhaber + 
				", Stand =" + stand + "]";
	}
	public List<Long> verlauf()
	{
		return history;
	}
	public long addToVerlauf(long betrag)
	{
		history.add(betrag);
		return betrag;
	}
	
}
