package de.hs_mannheim.informatik.bank.facade;



import java.io.IOException;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;

import de.hs_mannheim.informatik.bank.domain.Bank;
import de.hs_mannheim.informatik.bank.domain.Konto;
import persistance.Read;
import persistance.Write;

public class Banksystem {
	private Bank bank;
	
	public Banksystem(String bankname) {
		this.bank = new Bank(bankname);
	}
	
	public int kontoAnlegen(String name) {
		Konto k = new Konto(name);
		bank.addKonto(k);
		
		return k.getKontonummer();
	}
	
	public String[] getKontenliste() {
		Collection<Konto> konten = bank.getKontenliste();
		String[] liste = new String[konten.size()];
		
		int i = 0;
		for (Konto k : konten) {
			liste[i++] = k.toString(); 
		}
		
		return liste;
	}
	
	public String getBankname() {
		return bank.getName();
	}
	public long einzahlen(int nummer,long betrag)
	{
		Collection<Konto> konten = bank.getKontenliste();

		for(Konto k : konten)
		{
			if(k.getKontonummer() == nummer)
			{
				k.addToVerlauf(betrag);
				k.einzahlen(betrag);
				return k.getStand();
			}
			
		}
		
		return 0;
	}
	public long ausziehen(int nummer,long betrag)
	{
		Collection<Konto> konten = bank.getKontenliste();

		for(Konto k : konten)
		{
			if(k.getKontonummer() == nummer)
			{
				k.addToVerlauf(-betrag);
				k.ausziehen(betrag);
				return k.getStand();
			}
			
		}
		
		return 0;
	}
	public long standsuchen(int nummer)
	{
		Collection<Konto> konten = bank.getKontenliste();
		for(Konto k : konten)
		{
			if(k.getKontonummer() == nummer)
			{
				return k.getStand();
			}
			
		}
		
		return -1;
	}
	public List<Long> zeigeVerlauf(int nummer)
	{
		Collection<Konto> konten = bank.getKontenliste();
		for(Konto k : konten)
		{
			if(k.getKontonummer() == nummer)
			{
				return k.verlauf();
			}
			
		}
		
		return null;
	}
	public boolean laden() throws ClassNotFoundException
	{
		Read r = new Read();
		HashMap<Integer,Konto> x = r.load();
		if(x == null) return false;
		bank.setKonten(r.load());
		return true;
	
	}
	public boolean speichern() 
	{
		Write w = new Write();
		return w.saveFile(bank.getKonten());
		
		
	}

}
